/*
alert tcp $EXTERNAL_NET any -> $HOME_NET any (msg: "WEB-MISC Pidgin MSN MSNP2P message integer overflow attempt"; flow: established, to_client; content: "application/x-msnmsgrp2p"; nocase; content: "P2P-Dest"; nocase; pcre:"/P2P-Dest[^\n]*\n\r?\n/i"; classtype: misc-attack; reference: cve, 2008-2927; reference:bugtraq, 29956; metadata:policy balanced-ips drop, policy security-ips drop; sid: 14263;)
*/
/*
 * Use at your own risk.
 *
 * Copyright (C) 2005-2008 Sourcefire, Inc.
 * 
 * This file is autogenerated via rules2c, by Brian Caswell <bmc@sourcefire.com>
 */


#include "sf_snort_plugin_api.h"
#include "sf_snort_packet.h"


/* declare detection functions */
int rule14263eval(void *p);

/* declare rule data structures */
/* precompile the stuff that needs pre-compiled */
/* flow:established, to_client; */
static FlowFlags rule14263flow0 = 
{
    FLOW_ESTABLISHED|FLOW_TO_CLIENT
};

static RuleOption rule14263option0 =
{
    OPTION_TYPE_FLOWFLAGS,
    {
        &rule14263flow0
    }
};
// content:"application/x-msnmsgrp2p", nocase; 
static ContentInfo rule14263content1 = 
{
    (u_int8_t *) "application/x-msnmsgrp2p", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_NOCASE|CONTENT_BUF_RAW, /* flags */ // XXX - need to add CONTENT_FAST_PATTERN support
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0 /* increment length*/
};

static RuleOption rule14263option1 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule14263content1
    }
};
// content:"P2P-Dest", nocase; 
static ContentInfo rule14263content2 = 
{
    (u_int8_t *) "P2P-Dest", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_NOCASE|CONTENT_BUF_RAW, /* flags */ // XXX - need to add CONTENT_FAST_PATTERN support
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0 /* increment length*/
};

static RuleOption rule14263option2 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule14263content2
    }
};
// pcre:"P2P-Dest[^\n]*\n\r?\n", nocase;
static PCREInfo rule14263pcre3 =
{
    "^P2P-Dest[^\\n]*\\n\\r?\\n", /* pattern */
    NULL,                               /* holder for compiled pattern */
    NULL,                               /* holder for compiled pattern flags */
    PCRE_CASELESS|PCRE_DOTALL|PCRE_MULTILINE,     /* compile flags */
    CONTENT_BUF_RAW     /* content flags */
};


static RuleOption rule14263option3 =
{
    OPTION_TYPE_PCRE,
    {
        &rule14263pcre3
    }
};

/* references for sid 14263 */
/* reference: bugtraq "29956"; */
static RuleReference rule14263ref1 = 
{
    "bugtraq", /* type */
    "29956" /* value */
};

/* reference: cve "2008-2927"; */
static RuleReference rule14263ref2 = 
{
    "cve", /* type */
    "2008-2927" /* value */
};

static RuleReference *rule14263refs[] =
{
    &rule14263ref1,
    &rule14263ref2,
    NULL
};
#ifdef HAS_METADATA
/* metadata for sid 14263 */
/* metadata:policy balanced-ips drop, policy security-ips drop; */

static RuleMetaData rule14263policy1 = 
{
    "policy balanced-ips drop"
};

static RuleMetaData rule14263policy2 = 
{
    "policy security-ips drop"
};


static RuleMetaData *rule14263metadata[] =
{
    &rule14263policy1,
    &rule14263policy2,
    NULL
};
#endif
RuleOption *rule14263options[] =
{
    &rule14263option0,
    &rule14263option1,
    &rule14263option2,
    &rule14263option3,
    NULL
};

Rule rule14263 = {
   
   /* rule header, akin to => tcp any any -> any any               */{
       IPPROTO_TCP, /* proto */
       "$EXTERNAL_NET", /* SRCIP     */
       "any", /* SRCPORT   */
       0, /* DIRECTION */
       "$HOME_NET", /* DSTIP     */
#ifdef NO_PORTLISTS
       "1863", /* DSTPORT   */
#else
       "[1863,3128,8080]", /* DSTPORT   */
#endif

   },
   /* metadata */
   { 
       3,  /* genid (HARDCODED!!!) */
       14263, /* sigid */
       2, /* revision */
   
       "attempted-user", /* classification */
       0,  /* hardcoded priority XXX NOT PROVIDED BY GRAMMAR YET! */
       "CHAT Pidgin MSN MSNP2P message integer overflow attempt",     /* message */
       rule14263refs /* ptr to references */
   #ifdef HAS_METADATA
       ,rule14263metadata
   #endif
   },
   rule14263options, /* ptr to rule options */
   &rule14263eval, /* use the built in detection function */
   0 /* am I initialized yet? */
};


/* detection functions */
int rule14263eval(void *p) {
    const u_int8_t *cursor_raw = 0;
    SFSnortPacket *sp = (SFSnortPacket *) p;
    
    const u_int8_t *end_of_payload;

    u_int32_t length, offset;

    if(sp == NULL)
        return RULE_NOMATCH;

    if(sp->payload == NULL)
        return RULE_NOMATCH;
    
    // flow:established, to_client;
    if (checkFlow(p, rule14263options[0]->option_u.flowFlags) > 0 ) {
        // content:"application/x-msnmsgrp2p", nocase;
        if (contentMatch(p, rule14263options[1]->option_u.content, &cursor_raw) > 0) {
            // content:"P2P-Dest", nocase;
            if (contentMatch(p, rule14263options[2]->option_u.content, &cursor_raw) > 0) {
                // pcre:"P2P-Dest[^\n]*\n\r?\n", nocase;
                if (pcreMatch(p, rule14263options[3]->option_u.pcre, &cursor_raw)) {
                    end_of_payload = sp->payload + sp->payload_size;

                    if ((cursor_raw + 27) >= end_of_payload)
                        return RULE_NOMATCH;

                    length = *(cursor_raw+8);
                    length |= *(cursor_raw+9) << 8;
                    length |= *(cursor_raw+10) << 16;
                    length |= *(cursor_raw+11) << 24;

                    offset = *(cursor_raw+24);
                    offset |= *(cursor_raw+25) << 8;
                    offset |= *(cursor_raw+26) << 16;
                    offset |= *(cursor_raw+27) << 24;

                    // If length + offset causes negative number or integer overflow, alert 
                    if(((length + offset) > 0x7fffffff) || ((length + offset) < length))
                        return RULE_MATCH;
                }
            }
        }
    }
    return RULE_NOMATCH;
}

/*
Rule *rules[] = {
    &rule14263,
    NULL
};
*/

