/* AUTOGENERATED FROM exploit_bea-jsessionid.rules
alert tcp $EXTERNAL_NET any -> $HOME_NET $HTTP_PORTS (msg:"EXPLOIT BEA WebLogic jsessionid buffer overflow attempt"; flow:to_server,established; content:"JSESSIONID="; nocase; isdataat:500,relative; pcre:"/^Cookie\x3a[^\n]*JSESSIONID=[^\n\x3b]{500}/smi"; metadata:policy balanced-ips drop, policy security-ips drop, service http; classtype:attempted-admin; sid:15010; rev:3;)

*/
/*
 * Use at your own risk.
 *
 * Copyright (C) 2005-2008 Sourcefire, Inc.
 * 
 * This file is autogenerated via rules2c, by Brian Caswell <bmc@sourcefire.com>
 */


#include "sf_snort_plugin_api.h"
#include "sf_snort_packet.h"


/* declare detection functions */
int rule15010eval(void *p);

/* declare rule data structures */
/* precompile the stuff that needs pre-compiled */
/* flow:established, to_server; */
static FlowFlags rule15010flow0 = 
{
    FLOW_ESTABLISHED|FLOW_TO_SERVER
};

static RuleOption rule15010option0 =
{
    OPTION_TYPE_FLOWFLAGS,
    {
        &rule15010flow0
    }
};
// content:"JSESSIONID=", depth 0, nocase; 
static ContentInfo rule15010content1 = 
{
    (u_int8_t *) "JSESSIONID=", /* pattern (now in snort content format) */
    0, /* depth */
    0, /* offset */
    CONTENT_NOCASE|CONTENT_BUF_NORMALIZED, /* flags */
    NULL, /* holder for boyer/moore PTR */
    NULL, /* more holder info - byteform */
    0, /* byteform length */
    0 /* increment length*/
};

static RuleOption rule15010option1 = 
{
    OPTION_TYPE_CONTENT,
    {
        &rule15010content1
    }
};
// isdataat:offset 500, relative;
static CursorInfo rule15010isdataat2 =
{
    500, /* offset */
    CONTENT_RELATIVE|CONTENT_BUF_NORMALIZED /* flags */
};

static RuleOption rule15010option2 =
{
    OPTION_TYPE_CURSOR,
    {
        &rule15010isdataat2
    }
};

// pcre:"^Cookie\x3a[^\n]*JSESSIONID=[^\n\x3b]{500}", dotall, multiline, nocase;
static PCREInfo rule15010pcre3 =
{
    "^Cookie\\x3a[^\\n]*JSESSIONID=[^\\n\\x3b]{500}", /* pattern */
    NULL,                               /* holder for compiled pattern */
    NULL,                               /* holder for compiled pattern flags */
    PCRE_CASELESS|PCRE_DOTALL|PCRE_MULTILINE,     /* compile flags */
    CONTENT_BUF_NORMALIZED     /* content flags */
};

static RuleOption rule15010option3 =
{
    OPTION_TYPE_PCRE,
    {
        &rule15010pcre3
    }
};

/* references for sid 15010 */
static RuleReference *rule15010refs[] =
{
    NULL
};
#ifdef HAS_METADATA
/* metadata for sid 15010 */
/* metadata:service http, policy balanced-ips drop, policy security-ips drop; */
static RuleMetaData rule15010service1 = 
{
    "service http"
};


static RuleMetaData rule15010policy1 = 
{
    "policy balanced-ips drop"
};

static RuleMetaData rule15010policy2 = 
{
    "policy security-ips drop"
};


static RuleMetaData *rule15010metadata[] =
{
    &rule15010service1,
    &rule15010policy1,
    &rule15010policy2,
    NULL
};
#endif
RuleOption *rule15010options[] =
{
    &rule15010option0,
    &rule15010option1,
    &rule15010option2,
    &rule15010option3,
    NULL
};

Rule rule15010 = {
   
   /* rule header, akin to => tcp any any -> any any               */{
       IPPROTO_TCP, /* proto */
       "$EXTERNAL_NET", /* SRCIP     */
       "any", /* SRCPORT   */
   
       0, /* DIRECTION */
       "$HOME_NET", /* DSTIP     */
   
       "$HTTP_PORTS", /* DSTPORT   */
   },
   /* metadata */
   { 
       3,  /* genid (HARDCODED!!!) */
       15010, /* sigid */
       3, /* revision */
   
       "attempted-admin", /* classification */
       0,  /* hardcoded priority XXX NOT PROVIDED BY GRAMMAR YET! */
       "EXPLOIT BEA WebLogic jsessionid buffer overflow attempt",     /* message */
       rule15010refs /* ptr to references */
   #ifdef HAS_METADATA
       ,rule15010metadata
   #endif
   },
   rule15010options, /* ptr to rule options */
   NULL, // &rule15010eval, /* use the built in detection function */
   0 /* am I initialized yet? */
};


/* detection functions */
int rule15010eval(void *p) {
    const u_int8_t *cursor_uri = 0;
    const u_int8_t *cursor_raw = 0;
    const u_int8_t *cursor_normal = 0;
    const u_int8_t *cursor_http_uri = 0;
    const u_int8_t *cursor_http_header = 0;
    const u_int8_t *cursor_http_client_body = 0;
    const u_int8_t *cursor_http_method = 0;
    SFSnortPacket *sp = (SFSnortPacket *) p;

    if(sp == NULL)
        return RULE_NOMATCH;

    if(sp->payload == NULL)
        return RULE_NOMATCH;
    
    // flow:established, to_server;
    if (checkFlow(p, rule15010options[0]->option_u.flowFlags) > 0 ) {
        // content:"JSESSIONID=", depth 0, nocase;
        if (contentMatch(p, rule15010options[1]->option_u.content, &cursor_normal) > 0) {
            // isdataat:offset 500, relative;
            if (checkCursor(p, rule15010options[2]->option_u.cursor, cursor_normal) > 0) {
                // pcre:"^Cookie\x3a[^\n]*JSESSIONID=[^\n\x3b]{500}", dotall, multiline, nocase;
                if (pcreMatch(p, rule15010options[3]->option_u.pcre, &cursor_normal)) {
                    return RULE_MATCH;
                }
            }
        }
    }
    return RULE_NOMATCH;
}

/*
Rule *rules[] = {
    &rule15010,
    NULL
};
*/
